[PATCH 1/7] Add a target to use the Coccinelle checker

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



A 'coccicheck' target is added. It can be called with four different
modes. Each one generates a different kind of output, i.e. context,
patch, org, report, according to the corresponding mode to be
activated.

The new target calls the 'coccicheck' front-end in the 'scripts'
directory with the MODE argument. Every SmPL file in the
subdirectories of 'scripts/coccinelle' is then given to the front-end
and applied to the entire source tree.

The four modes behave as follows:

'report' generates a list in the following format:
  file:line:column-column: message

'patch' proposes a fix, when possible.

'context' highlights lines of interest and their context in a
diff-like style. Lines of interest are indicated with '-'.

'org' generates a report in the Org mode format of Emacs.

Signed-off-by: Nicolas Palix <npalix@xxxxxxx>
Signed-off-by: Julia Lawall <julia@xxxxxxx>
---
 MAINTAINERS           |   10 +++++++++
 Makefile              |   10 ++++++--
 scripts/Makefile.help |    3 ++
 scripts/coccicheck    |   54 +++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 74 insertions(+), 3 deletions(-)
 create mode 100644 scripts/Makefile.help
 create mode 100755 scripts/coccicheck

diff --git a/MAINTAINERS b/MAINTAINERS
index 67accd7..5b3c95e 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1569,6 +1569,16 @@ L:	platform-driver-x86@xxxxxxxxxxxxxxx
 S:	Supported
 F:	drivers/platform/x86/classmate-laptop.c
 
+COCCINELLE/Semantic Patches (SmPL)
+M:	Julia Lawall <julia@xxxxxxx>
+M:	Gilles Muller <Gilles.Muller@xxxxxxx>
+M:	Nicolas Palix <npalix@xxxxxxx>
+L:	cocci@xxxxxxx (moderated for non-subscribers)
+W:	http://coccinelle.lip6.fr/
+S:	Supported
+F:	scripts/coccinelle/
+F:	scripts/coccicheck
+
 CODA FILE SYSTEM
 M:	Jan Harkes <jaharkes@xxxxxxxxxx>
 M:	coda@xxxxxxxxxx
diff --git a/Makefile b/Makefile
index 654c31a..09d9d08 100644
--- a/Makefile
+++ b/Makefile
@@ -412,7 +412,7 @@ endif
 # of make so .config is not included in this case either (for *config).
 
 no-dot-config-targets := clean mrproper distclean \
-			 cscope TAGS tags help %docs check% \
+			 cscope TAGS tags help %docs check% coccicheck \
 			 include/linux/version.h headers_% \
 			 kernelrelease kernelversion
 
@@ -1279,8 +1279,9 @@ help:
 	@echo  '  includecheck    - Check for duplicate included header files'
 	@echo  '  export_report   - List the usages of all exported symbols'
 	@echo  '  headers_check   - Sanity check on exported headers'
-	@echo  '  headerdep       - Detect inclusion cycles in headers'; \
-	 echo  ''
+	@echo  '  headerdep       - Detect inclusion cycles in headers'
+	@$(MAKE) -f $(srctree)/scripts/Makefile.help checker-help
+	@echo  ''
 	@echo  'Kernel packaging:'
 	@$(MAKE) $(build)=$(package-dir) help
 	@echo  ''
@@ -1439,6 +1440,9 @@ versioncheck:
 		-name '*.[hcS]' -type f -print | sort \
 		| xargs $(PERL) -w $(srctree)/scripts/checkversion.pl
 
+coccicheck:
+	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
+
 namespacecheck:
 	$(PERL) $(srctree)/scripts/namespace.pl
 
diff --git a/scripts/Makefile.help b/scripts/Makefile.help
new file mode 100644
index 0000000..d03608f
--- /dev/null
+++ b/scripts/Makefile.help
@@ -0,0 +1,3 @@
+
+checker-help:
+	@echo  '  coccicheck      - Check with Coccinelle.'
diff --git a/scripts/coccicheck b/scripts/coccicheck
new file mode 100755
index 0000000..037424b
--- /dev/null
+++ b/scripts/coccicheck
@@ -0,0 +1,54 @@
+#!/bin/sh
+
+SPATCH="`which ${SPATCH:=spatch}`"
+
+if [ ! -x "$SPATCH" ]; then
+    echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
+    exit 1
+fi
+
+if [ "$MODE" = "" ] ; then
+    echo 'You have not explicitly specify the mode to use. Fallback to "report".'
+    echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
+    echo 'Available modes are: report, patch, context, org'
+    MODE="report"
+fi
+
+echo ''
+echo 'Please check for false positives in the output before submitting a patch.'
+echo 'When using "patch" mode, carefully review the patch before submitting it.'
+echo ''
+
+function coccinelle {
+    COCCI="$1"
+    DIR="$2"
+
+    OPT=`grep "Option" $COCCI | cut -d':' -f2`
+    FILE=`echo $COCCI | sed "s|$DIR/||"`
+
+    echo "Processing `basename $COCCI` with option(s) \"$OPT\""
+    echo 'Message example to submit a patch:'
+
+    sed -e '/\/\/\//!d' -e 's|^///||' $COCCI
+
+    echo ' The semantic patch that makes this change is available'
+    echo " in $FILE."
+    echo ''
+    echo ' More information about semantic patching is available at'
+    echo ' http://coccinelle.lip6.fr/'
+    echo ''
+
+#   The option '-parse_cocci' can be used to syntaxically check the SmPL files.
+#
+#    $SPATCH -D $MODE -very_quiet -parse_cocci $COCCI $OPT > /dev/null
+
+    $SPATCH -D $MODE -very_quiet -sp_file $COCCI $OPT -dir $DIR
+}
+
+if [ "$COCCI" = "" ] ; then
+    for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
+	coccinelle $f $srctree;
+    done
+else
+    coccinelle $COCCI $srctree
+fi
-- 
1.7.0.4

--
To unsubscribe from this list: send the line "unsubscribe kernel-janitors" in
the body of a message to majordomo@xxxxxxxxxxxxxxx
More majordomo info at  http://vger.kernel.org/majordomo-info.html


[Index of Archives]     [Kernel Development]     [Kernel Announce]     [Kernel Newbies]     [Linux Networking Development]     [Share Photos]     [IDE]     [Security]     [Git]     [Netfilter]     [Yosemite News]     [MIPS Linux]     [ARM Linux]     [Device Mapper]

  Powered by Linux